local N, T = ...

function T.Setup_Debug()
    T.Register_Event("CINEMATIC_START", print)
    T.Register_Event("CINEMATIC_STOP", print)
    T.Register_Event("HIDE_SUBTITLE", print)
    T.Register_Event("PLAY_MOVIE", print)
    T.Register_Event("ADDON_LOADED", print)
    T.Register_Event(
        "PLAYER_LEVEL_UP",
        function(...)
            print(...)
            print(UnitLevel("player"))
        end
    )
    T.Register_Event(
        "WHO_LIST_UPDATE",
        function(event)
            print(event, C_FriendList.GetNumWhoResults())
        end
    )

    -- T.Register_Event("VIGNETTE_MINIMAP_UPDATED", print)
    -- T.Register_Event("NAME_PLATE_UNIT_ADDED", print)
    -- local autoloot_backup
    -- T.Register_Event(
    --     "LOOT_READY",
    --     function(autoloot)
    --         autoloot_backup = autoloot
    --         if IsFishingLoot() or UnitIsDead("target") then
    --             C_CVar.SetCVar("autoLootDefault", "1")
    --         end
    --     end
    -- )
    -- T.Register_Event(
    --     "LOOT_OPENED",
    --     function(event, auto_loot, is_from_item)
    --         print(event, auto_loot, is_from_item)
    --         if auto_loot then
    --             return
    --         end
    --         if IsFishingLoot() or UnitIsDead("target") then
    --             LootSlot(1)
    --         end
    --     end
    -- )
    -- T.Register_Event(
    --     "LOOT_CLOSED",
    --     function()
    --         C_CVar.SetCVar("autoLootDefault", autoloot_backup)
    --     end
    -- )
    -- T.Register_Event("LOOT_SLOT_CHANGED", print)
    -- T.Register_Event(
    --     "LOOT_SLOT_CHANGED",
    --     function(event, slot)
    --         if IsFishingLoot() or UnitIsDead("target") then
    --             LootSlot(slot + 1)
    --         end
    --     end
    -- )

    --[[ 测试脚本
    /run StaticPopup_Show("ERROR_CINEMATIC")
    /run StaticPopup_Show("MAC_OPEN_UNIVERSAL_ACCESS")
    /run StaticPopup_Show("GUILDBANK_DEPOSIT")
    /run StaticPopup_Show("GUILDBANK_WITHDRAW")
    /run StaticPopup_Show("LFG_LIST_AUTO_ACCEPT_CONVERT_TO_RAID")
    /run StaticPopup_Show("LFG_QUEUE_EXPAND")    
    /run StaticPopup_Show("CAMP")    
    --]]
    -- 鼠标提示，调试用
    local function on_tooltip(self)
        local _, item_link = self:GetItem()
        if not item_link then
            return
        end
        local item = Item:CreateFromItemLink(item_link)
        if item:IsItemEmpty() then
            return
        end
        item:ContinueOnItemLoad(
            function()
                local id = item:GetItemID()
                self:AddLine("GetItemID() = " .. T.ToString(id))
                self:AddLine("CanTransmogItem() = " .. T.ToString(C_Transmog.CanTransmogItem(id)))
                -- self:AddLine("item:GetInventoryType() = " .. T.ToString(item:GetInventoryType()))
                -- self:AddLine(
                --     "C_Transmog.GetSlotForInventoryType() = " ..
                --         T.ToString(C_Transmog.GetSlotForInventoryType(item:GetInventoryType() + 1))
                -- )
                -- self:AddLine("C_Transmog.CanTransmogItem() = " .. T.ToString(C_Transmog.CanTransmogItem(item_link)))
                self:AddLine(
                    "PlayerHasTransmog() = " .. T.ToString(C_TransmogCollection.PlayerHasTransmog(item:GetItemID()))
                )
                local appearance_id, source_id = C_TransmogCollection.GetItemInfo(item_link)
                -- self:AddLine("C_TransmogCollection.GetItemInfo() = " .. T.ToString(appearance_id, source_id))
                if appearance_id and source_id then
                    --     self:AddLine(
                    --         "C_TransmogCollection.GetAllAppearanceSources() = " ..
                    --             T.ToString(C_TransmogCollection.GetAllAppearanceSources(appearance_id))
                    --     )
                    self:AddLine(
                        "PlayerCanCollectSource() = " ..
                            T.ToString(C_TransmogCollection.PlayerCanCollectSource(source_id))
                    )
                -- self:AddLine(
                --     "C_TransmogCollection.GetSourceInfo() = " ..
                --         T.ToString(C_TransmogCollection.GetSourceInfo(source_id))
                -- )
                end
            end
        )
    end
    GameTooltip:HookScript("OnTooltipSetItem", on_tooltip)
    ItemRefTooltip:HookScript("OnTooltipSetItem", on_tooltip)

    GameTooltip:HookScript(
        "OnTooltipSetSpell",
        function(self)
            local _, spell_id = self:GetSpell()
            if not spell_id then
                return
            end
            self:AddLine("spell_id = " .. spell_id)
            self:AddLine("GetSpellBaseCooldown() = " .. T.ToString(GetSpellBaseCooldown(spell_id)))
            self:AddLine("GetSpellCooldown() = " .. T.ToString(GetSpellCooldown(spell_id)))
        end
    )

    GameTooltip:HookScript(
        "OnTooltipSetUnit",
        function(self)
            local uname, uid = self:GetUnit()
            if uid then
                self:AddLine("GetUnit() = " .. T.ToString(uname, uid))
                self:AddLine("UnitGUID() = " .. UnitGUID(uid))
            end
        end
    )

    local function trp3_serialize(obj)
        local func =
            ({
            ["nil"] = function()
                return "nil"
            end,
            boolean = tostring,
            number = tostring,
            string = function(input)
                return ("%q"):format(input)
            end,
            table = function(input)
                local output = {}
                for k, v in pairs(input) do
                    if type(k) == "string" then
                        table.insert(output, string.format("%s=%s", k, trp3_serialize(v)))
                    else
                        table.insert(output, string.format("[%s]=%s", trp3_serialize(k), trp3_serialize(v)))
                    end
                end
                return string.format("{%s}", table.concat(output, ","))
            end
        })[type(obj)]
        assert(func)
        return func(obj)
    end

    -- T.Register_Event(
    --     "CHAT_MSG_ADDON",
    --     function(ev, prefix, text, channel, sender, target, zoneChannelID, localID, name, instanceID)
    --         print(ev, prefix, text, channel, sender, target, zoneChannelID, localID, name, instanceID)
    --         if (channel == "WHISPER") then

    --         end
    --     end
    -- )


end
