local N, T = ...

function T.Setup_Macro()
    local player_race = ({UnitRace("player")})[2]
    local player_class = ({UnitClass("player")})[2]
    local player_faction = ({UnitFactionGroup("player")})[1]
    local player_level = UnitLevel("player")
    local player_covenant = C_Covenants.GetActiveCovenantID()

    local covenant_ability_ids = {
        -- 格里恩，温西尔，法夜，通灵
        DEATHKNIGHT = {312202, 311648, 324128, 315443},
        DEMONHUNTER = {306830, 317009, 323639, 350570},
        DRUID = {326434, 323546, 323764, 325727},
        HUNTER = {308491, 324149, 328231, 325028},
        MAGE = {307443, 314793, 314791, 324220},
        MONK = {310454, 326860, 327104, 325216},
        PALADIN = {304971, 316958, 328620, 328204},
        PRIEST = {325013, 323673, 327661, 324724},
        ROGUE = {323547, 323654, 328305, 328547},
        SHAMAN = {324386, 320674, 328923, 326059},
        WARLOCK = {312321, 321792, 325640, 325289},
        WARRIOR = {307865, 317485, 325886, 324143},
        Signature = {324739, 300728, 310143, 324631}
    }
    local cast_at_player = {
        [325216] = true
    }
    local function covenant_ability_macro(c)
        local spell_id = covenant_ability_ids[c][player_covenant]
        local spell_name = GetSpellInfo(spell_id)
        if cast_at_player[spell_id] then
            return string.format("#showtooltip\n/cast [@player] %s\n", spell_name)
        else
            return string.format("#showtooltip\n/cast %s\n", spell_name)
        end
    end
    -- for class, sids in pairs(covenant_ability_ids) do
    --     for cov, sid in ipairs(sids) do
    --         print(class, cov, GetSpellInfo(sid), GetSpellDescription(sid))
    --     end
    -- end

    local global_macros = {
        -- ["躺下"] = "/lie\n",
        ["扔"] = "#showtooltip\n/cancelaura 神圣惩戒\n/use 画着芜菁的“枪”\n/use 水果篮\n/use 裂心者\n/use 达拉然飞碟\n/use 足球\n",
        ["足球"] = "#showtooltip\n/cancelaura 神圣惩戒\n/use 足球\n/sit\n",
        ["手球"] = "#showtooltip\n/cancelaura 神圣惩戒\n/use 橄榄球\n/sit\n",
        ["玩具"] = "/use 上层精灵的灵魂镜\n/use 个人全息投影仪\n/use 大法师瓦格斯的备用法杖\n/use 山丘之王的圣杯\n/use 怨恨尖塔\n/use 星图\n/use 松软的绿色沙发垫\n/use 炉石游戏盘\n/use 烈焰舞娘火盆\n/use 神奇的啤酒桶\n/use 莉莉安的警告牌\n/use 永恒沙漏\n/use 堆叠式雄鹿\n/use 寄魂战鼓\n/use 旧娃娃\n/use 浪漫午餐篮\n/use 燃烧军团便携传送门\n/use 虚空图腾\n/use 记忆之盒\n/use 集结战旗\n",
        -- ["邀会"] = "/ginvite\n",
        ["堆栈"] = "/fstack\n",
        -- ["强e"] = "/use [combat] 13\n/use [combat] 14\n/use [combat] 改装的邪能焦镜\n/use [combat] 奥拉留斯的低语水晶\n",
        -- ["强p"] = "/use [combat] 联盟军旗\n/use [combat] 部落军旗\n/use [combat] 护火者之誓\n",
        ["披风"] = "#showtooltip\n/dismount [flying]\n/cancelform [flying]\n/use 15\n/use 远程拾取器\n/use 芬德尔的远程拾取器\n/cast 拾回\n",
        ["腰带"] = "#showtooltip\n/use 6\n",
        ["EAB"] = "/click ExtraActionButton1\n",
        ["节日"] = "#showtooltip\n/cast 钓鱼\n/use 先祖硬币\n/use 红包\n/use 一把糖果\n/use 封印的暗月箱子\n",
        ["日常"] = "/tar 偷懒的龙喉苦工\n/use 训诫靴\n/use 亚兹尔的羊肉\n/use 天空卫队的炸弹\n/use 冠军的钱包\n/use 震地者之鼓\n/use 烈焰之矛\n/use 缴获的克瓦迪尔旗帜\n/use 疣无忧唇膏\n/kiss\n/use 加重的扣网\n/use 唤雾者的符咒\n/use 克瓦迪尔战争号角\n/use 光明祝福圣物\n/use 忏悔者的祈祷书\n/use 新鲜的鱼饵\n/use 狼的尖牙\n/use 魔法药膏\n/use 磁性废料收集器\n/use 戳鸟之矛\n",
        ["离开"] = "/sit\n/afk\n",
        -- ["挥动"] = "/use [@player] 怒根之种\n/use 神圣香炉\n",
        ["观察"] = '/script InspectUnit("target")\n',
        ["Cry"] = '/run if cr then cr:Cancel()cr=nil print("Cry OFF") else DoEmote("kneel")cr=C_Timer.NewTicker(6,function()DoEmote("cry")end)print("Cry ON")end\n',
        ["Dance"] = '/run if da then da:Cancel()da=nil print("Dance OFF") else da=C_Timer.NewTicker(11,function()DoEmote("stand")C_Timer.After(math.random(4,6)/10, function()DoEmote("dance")end)end)print("Dance ON")end\n',
        ["Chicken"] = '/run if ch then ch:Cancel()ch=nil print("Chicken OFF") else ch=C_Timer.NewTicker(7,function()DoEmote("chicken")end)print("Chicken ON")end\n',
        ["Laugh"] = '/run if la then la:Cancel()la=nil print("Laugh OFF") else la=C_Timer.NewTicker(8,function()DoEmote("laugh")end)print("Laugh ON")end\n',
        ["Mountspecial"] = '/run if mo then mo:Cancel()mo=nil print("Mountspecial OFF") else mo=C_Timer.NewTicker(60,function()DoEmote("mountspecial")end)print("Mountspecial ON")end\n',
        ["Turkey"] = '/run if tu then tu:Cancel()tu=nil print("Turkey OFF") else tu=C_Timer.NewTicker(27,function()local id="BattlePet-0-0000066A198E" if C_PetJournal.GetSummonedPetGUID()~=id then C_PetJournal.SummonPetByGUID(id)end end)print("Turkey ON")end\n',
        ["Follow"] = '/run if fo then fo:Cancel()fo=nil print("Follow OFF") else fo=C_Timer.NewTicker(3,function()FollowUnit("focus")end)print("Follow ON")end\n',
        -- ["MAX"] = '/run print("/* MAX开头的全局变量 */")for k, v in pairs(_G) do if k:find("^MAX_") then print(k.."=", v)end end\n',
        -- ["MIN"] = '/run print("/* MIN开头的全局变量 */")for k, v in pairs(_G) do if k:find("^MIN_") then print(k.."=", v)end end\n',
        -- ["猎手阿图门"] = "/tar 猎手阿图门\n",
        -- ["黑心"] = "/tar 布尔吉·黑心\n/cast 英勇投掷\n",
        ["旗"] = "#showtooltip\n/use 协同战旗\n/use 神秘水果帽\n/use 世界缩小器\n/use 巨怒射线枪\n/lie\n/afk\n",
        -- ["CD"] = "/w 恩托哇-瓦里安 9\n/w 太阳断月之弦-末日行者 9\n/w 咩咩的羊羔-金色平原 9\n/w 咩咩的羊羔-瓦里安 9\n/w 愤怒的羊羊-瓦拉纳 9\n/w 咩咩的猎手-金色平原 9\n/w 愤怒的羊羊-冰霜之刃 9\n",
        -- ["CCA"] = covenant_ability_macro(player_class),
        -- ["CSA"] = covenant_ability_macro("Signature")
        ["骨尘"] = "#showtooltip\n/cast [@player] 骨尘酒\n",
        ["影遁"] = "#showtooltip\n/use [combat] 家传的联盟徽记\n/use [combat] 纯净的第三月碎片\n/cast [combat,nostealth] !影遁;!潜行\n"
    }

    local class_macros = {
        DRUID = {
            ["跑"] = "#showtooltip\n/cast [noform:3,outdoors][noform:3,swimming] 旅行形态(变形)\n/cast [noform:2/3,indoors][form:3,noflying] 猎豹形态\n/cast [form:2,indoors] 熊形态\n/use 侏儒X光眼镜\n/use 格里恩之铃\n/use 天界之鼓\n", -- /use 布尔吉·黑心的时装帽\n 法夜形态也是form，GetShapeshiftForm()=7
            ["潜行"] = "#showtooltip\n/cancelaura [nocombat] 树皮术\n/cast !潜行\n",
            ["自疗"] = "#showtooltip\n/castsequence [spec:1/2/3,talent:3/3,@player] reset=15 回春术,迅捷治愈,愈合,愈合,愈合\n/cast [notalent:3][spec:1/2/3,talent:3/1,@player][spec:1/2/3,talent:3/2,@player][spec:4,@player] 愈合\n",
            ["月火"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/cast 月火术\n",
            ["愤怒"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/cast 愤怒\n",
            ["日月"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/castsequence [nomod] reset=9,target,combat 阳炎术,月火术\n/cast [mod] 星辰坠落\n/use [combat,nomod] 13\n/use [combat,nomod] 14\n/use [combat,nomod] 改装的邪能焦镜\n/use [combat,nomod] 奥拉留斯的低语水晶\n",
            ["星怒"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/castsequence [spec:1] reset=20 星火术,愤怒\n/castsequence [nospec:1] reset=20 星火术,愤怒\n",
            ["星涌"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/cast 星涌术\n/use [combat] 联盟军旗\n/use [combat] 部落军旗\n/use [combat] 护火者之誓\n",
            ["野行"] = (function()
                if player_level < 21 then
                    return "#showtooltip\n/cast [nocombat] !潜行;斜掠\n"
                else
                    return "#showtooltip\n/cast [nocombat] !潜行\n/cast [combat,talent:6/3] 原始之怒\n/cast [combat,notalent:6/3] 割裂\n"
                end
            end)(),
            ["野性"] = (function()
                if player_level < 23 then
                    return "#showtooltip\n/targetenemy [noharm][dead]\n/cast 月火术\n/startattack\n/cast [combat] 猛虎之怒\n"
                else
                    return "#showtooltip\n/targetenemy [noharm][dead]\n/castsequence reset=combat,12 斜掠,痛击,横扫,横扫,横扫\n/startattack\n/cast [combat] 猛虎之怒\n/use [combat] 13\n/use [combat] 14\n/use [combat] 改装的邪能焦镜\n/use [combat] 奥拉留斯的低语水晶\n"
                end
            end)(),
            ["撕咬"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/cast 凶猛撕咬\n",
            ["守行"] = (function()
                if player_level < 23 then
                    return "#showtooltip\n/cast [combat] 痛击;猎豹形态(变形)\n/targetenemy [noharm,combat][dead,combat]\n/startattack [combat]\n/cast [combat] 树皮术\n"
                else
                    return "#showtooltip\n/cast [combat] 痛击;猎豹形态(变形)\n/targetenemy [noharm,combat][dead,combat]\n/startattack [combat]\n/cast [combat] 铁鬃\n/cast [combat] 树皮术\n/use [combat] 13\n/use [combat] 14\n"
                end
            end)(),
            -- /cast [combat] 狂暴\n/cast [combat] 饕餮狂乱\n
            ["守护"] = (function()
                if player_level < 23 then
                    -- elseif player_level < 23 then
                    --     return "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/castsequence reset=4 裂伤,月火术,月火术,!痛击\n/cast [combat] 铁鬃\n/use [combat] 13\n/use [combat] 14\n/cast [mod] 低吼\n"
                    return "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/castsequence reset=3 裂伤,重殴\n/cast [mod] 低吼\n"
                else
                    return "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/cast [nocombat] 横扫\n/castsequence [combat] reset=4 裂伤,横扫,月火术,!痛击\n/cast [combat] 铁鬃\n/cast [combat] 树皮术\n/use [combat] 13\n/use [combat] 14\n/use [combat] 改装的邪能焦镜\n/use [combat] 奥拉留斯的低语水晶\n/cast [mod] 低吼\n"
                end
            end)()
        },
        HUNTER = {
            -- ["跑"] = "#showtooltip\n/stopattack\n/stopattack\n/petfollow\n/cast [combat][indoors] 猎豹守护\n/use [nocombat,outdoors,spec:1] !狩猎大师的忠诚狼鹰\n/use [nocombat,outdoors,spec:2] !狩猎大师的恐怖狼鹰\n/use [nocombat,outdoors,spec:3] !狩猎大师的凶猛狼鹰\n",
            ["跑"] = "#showtooltip\n/stopattack\n/stopattack\n/petfollow\n/use [nocombat,nomounted,outdoors] 布尔吉·黑心的时装帽\n/use [spec:1] !狩猎大师的忠诚狼鹰\n/use [spec:2] !狩猎大师的恐怖狼鹰\n/use [spec:3] !狩猎大师的凶猛狼鹰\n",
            ["逃脱"] = "#showtooltip\n/stopattack\n/stopattack\n/petfollow\n/cast 逃脱\n/cast [combat,@player] 冰冻陷阱\n",
            -- ["鹰眼"] = "#showtooltip\n/cast !鹰眼术\n",
            -- ["兽王"] = player_level < 37 and "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/petattack\n/castsequence reset=6 杀戮命令,倒刺射击,!眼镜蛇射击,!治疗宠物,!杀戮命令,眼镜蛇射击,眼镜蛇射击\n/cast [combat] 野性守护\n/cast [combat,@pet] 误导\n/use [combat] 13\n/use [combat] 14\n/use [combat] 改装的邪能焦镜\n/use [combat] 奥拉留斯的低语水晶\n" or "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/petattack\n/castsequence reset=6 杀戮命令,多重射击,治疗宠物,倒刺射击,杀戮命令,多重射击,眼镜蛇射击,宁神射击\n/cast [combat] 野性守护\n/cast [combat,@pet] 误导\n/use [combat] 13\n/use [combat] 14\n/use [combat] 改装的邪能焦镜\n/use [combat] 奥拉留斯的低语水晶\n",
            -- ["双龙"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/petattack\n/cast 奇美拉射击\n",
            ["夺命"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/petattack\n/cast 夺命射击\n",
            ["兽王"] = (function()
                if player_level < 11 then
                    return "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/petattack\n/castsequence reset=4 杀戮命令,稳固射击,稳固射击,稳固射击\n"
                elseif player_level < 12 then
                    return "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/petattack\n/castsequence reset=4 杀戮命令,稳固射击,奥术射击,稳固射击\n"
                elseif player_level < 14 then
                    return "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/petattack\n/castsequence reset=4 杀戮命令,奥术射击,奥术射击\n"
                else
                    -- return "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/petattack\n/castsequence [nomod] reset=3 杀戮命令,眼镜蛇射击,眼镜蛇射击\n/cast [mod] 多重射击\n/cast [combat] 野性守护\n/use [combat] 13\n/use [combat] 14\n/use [combat] 改装的邪能焦镜\n/use [combat] 奥拉留斯的低语水晶\n"
                    return "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/petattack\n/castsequence [nomod] reset=3 杀戮命令,眼镜蛇射击,眼镜蛇射击\n/cast [mod] 多重射击\n/cast [combat] 野性守护\n/cast [combat,@pet] 误导\n/use [combat] 13\n/use [combat] 14\n/use [combat] 改装的邪能焦镜\n/use [combat] 奥拉留斯的低语水晶\n"
                end
            end)(),
            ["倒刺"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/petattack\n/cast 倒刺射击\n/use [combat] 庆典烟火\n",
            ["灵魂"] = "#showtooltip\n/cast [@player] 灵魂治愈(稀有技能)\n",
            ["震荡"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/petattack\n/cast 震荡射击\n",
            ["弹幕"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/petattack\n/cast [nochanneling] 弹幕射击\n",
            ["奥术"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/petattack\n/cast [nomod,nochanneling] 奥术射击\n/cast [mod,nochanneling] 多重射击\n",
            ["稳固"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/petattack\n/cast [nochanneling] 稳固射击\n",
            ["多重"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/petattack\n/cast [nochanneling] 多重射击\n",
            -- ["瞄准"] = "#showtooltip\n/targetenemy [noharm][dead]\n/stopattack\n/petattack\n/castsequence [nochanneling] reset=10 瞄准射击,奥术射击,急速射击,瞄准射击,奥术射击\n",
            ["生2"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/petattack\n/castsequence reset=combat,3 毒蛇钉刺,稳固射击,奥术射击,杀戮命令,稳固射击,奥术射击,稳固射击,杀戮命令\n/equip 精致的上古骨弓\n",
            ["生3"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/petattack\n/castsequence reset=combat,3 猛禽一击,杀戮命令\n/cast 鱼叉猛刺\n/equip 抛光的典狱官法杖\n",
            ["杀戮"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/petattack\n/cast 杀戮命令\n",
            ["野火"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/petattack\n/cast 野火炸弹\n",
            ["射击"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/petattack\n/castsequence [talent:1/2] reset=6,target,combat 毒蛇钉刺,稳固射击,奥术射击,稳固射击,奥术射击,稳固射击\n/cast [notalent:1/2] 奥术射击\n",
            ["射爆"] = (function()
                if player_level < 20 then
                    return "#showtooltip\n/targetenemy [noharm][dead]\n/cast 瞄准射击\n"
                else
                    return "#showtooltip\n/targetenemy [noharm][dead]\n/castsequence [nochanneling] reset=15 瞄准射击,瞄准射击,急速射击\n"
                end
            end)()
        },
        MAGE = {
            ["跑"] = "#showtooltip\n/stopcasting\n/stopcasting\n/stopattack\n/petfollow\n/cast [nocombat,outdoors,@player] 奥术智慧\n/use [nocombat,outdoors] !大法师的棱光飞碟;闪现术\n",
            ["缓落"] = "#showtooltip\n/cast [@player] 缓落术\n",
            -- ["净化"] = "#showtooltip\n/cast [harm] 法术吸取\n/cast 解除诅咒\n",
            ["盾"] = "#showtooltip\n/cast [spec:1] 棱光护体\n/cast [spec:2] 烈焰护体\n/cast [spec:3] 寒冰护体\n/use 改装的邪能焦镜\n/use 奥拉留斯的低语水晶\n",
            ["魔爆"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/cast 魔爆术\n/use [combat] 13\n/use [combat] 14\n",
            ["奥术"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/castsequence [nochanneling] reset=combat,6,target 奥术飞弹,奥术弹幕\n",
            ["飞弹"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/cast [nochanneling] 奥术飞弹\n",
            ["弹幕"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/cast 奥术弹幕\n",
            ["智慧"] = "#showtooltip\n/cast [@player] 奥术智慧\n",
            ["冰枪"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/petattack\n/cast 冰枪术\n",
            ["冰箭"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/petattack\n/cast 寒冰箭\n",
            ["法力"] = "#showtooltip\n/use 法力宝石\n/cast 制造法力宝石\n",
            ["面包"] = "#showtooltip\n/use 魔法布朗尼蛋糕\n/cast 造餐术\n"
        },
        ROGUE = {
            -- ["跑"] = "#showtooltip\n/cast [combat][indoors] 疾跑\n/use [noflyable,nocombat,outdoors] !铁箍鬼灵战马\n/use [flyable,nocombat,outdoors,spec:1] !暗影之刃的致命预兆\n/use [flyable,nocombat,outdoors,spec:2] !暗影之刃的猩红预兆\n/use [flyable,nocombat,outdoors,spec:3] !暗影之刃的怨恨预兆\n",
            ["跑"] = "#showtooltip\n/use [nocombat,outdoors] !铁箍鬼灵战马;疾跑\n",
            ["消失"] = "#showtooltip\n/cast 石像形态(种族特长)\n/cast 暗影斗篷\n/cast 闪避\n/cast 消失\n",
            ["刺行"] = "#showtooltip\n/cast [nocombat,nostealth] !潜行\n/cast [stealth] 偷袭\n/cast [combat] 割裂\n",
            -- ["刺杀"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/castsequence reset=6 锁喉,毁伤,割裂,毁伤,毁伤,毒伤,毁伤,毁伤,毒伤\n/cast [combat,@focus] 嫁祸诀窍\n/use [combat] 13\n/use [combat] 14\n/use [combat] 改装的邪能焦镜\n/use [combat] 奥拉留斯的低语水晶\n",
            ["刺杀"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/castsequence reset=6 锁喉,刀扇,刀扇,刀扇,刀扇,刀扇,刀扇,刀扇\n/cast [combat,@focus] 嫁祸诀窍\n/use [combat] 13\n/use [combat] 14\n/use [combat] 改装的邪能焦镜\n/use [combat] 奥拉留斯的低语水晶\n",
            ["脚踢"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/cast 脚踢\n/cast [spec:1] 剧毒之刃\n",
            ["敏行"] = "#showtooltip\n/cast [nocombat] !潜行;割裂\n",
            ["晕"] = "#showtooltip\n/cast [stealth] 偷袭;肾击\n",
            ["敏锐"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/cast [nomod] 背刺;袖剑风暴\n"
        },
        DEATHKNIGHT = {
            -- ["跑"] = "#showtooltip\n/use [nocombat,outdoors] !铁箍鬼灵战马;死亡脚步\n",
            ["跑"] = "#showtooltip\n/use !铁箍鬼灵战马\n",
            ["加速"] = "#showtooltip\n/castsequence [nochanneling,spec:1,talent:5/3] [nochanneling,spec:2,talent:5/2] [nochanneling,spec:3,talent:5/2] reset=45 死亡脚步,幻影步,死亡脚步,幻影步,死亡脚步,死亡脚步,幻影步\n/cast [nochanneling] 死亡脚步\n",
            -- ["血"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/castsequence [nogroup] reset=4 心脏打击,血液沸腾,心脏打击\n/castsequence [group] reset=8 骨髓分裂,血液沸腾,心脏打击,心脏打击,血液沸腾\n/use [combat] 13\n/use [combat] 14\n/use [combat] 改装的邪能焦镜\n/use [combat] 奥拉留斯的低语水晶\n",
            -- ["血"] = player_level > 20 and "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/castsequence reset=9 骨髓分裂,血液沸腾,心脏打击,心脏打击,血液沸腾\n/cast [mod] 黑暗命令\n/cast [combat] 符文分流\n/cast [combat] 活力分流\n/use [combat] 13\n/use [combat] 14\n" or "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/castsequence [nochanneling] reset=9 骨髓分裂,血液沸腾,心脏打击,心脏打击,血液沸腾\n/cast [combat] 符文分流\n/use [combat] 13\n/use [combat] 14\n/use [combat] 庆典烟火\n",
            ["血"] = (function()
                if player_level < 11 then
                    return "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/cast 心脏打击\n/cast [mod] 黑暗命令\n/cast [combat] 亡者复生\n/use [combat] 13\n/use [combat] 14\n"
                elseif player_level < 17 then
                    return "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/castsequence reset=9 骨髓分裂,心脏打击,心脏打击\n/cast [mod] 黑暗命令\n/cast [combat] 亡者复生\n/use [combat] 13\n/use [combat] 14\n"
                elseif player_level < 54 then
                    return "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/castsequence reset=9 骨髓分裂,血液沸腾,心脏打击,心脏打击,血液沸腾\n/cast [mod] 黑暗命令\n/cast [combat] 亡者复生\n/use [combat] 13\n/use [combat] 14\n"
                else
                    return "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/castsequence reset=9 骨髓分裂,血液沸腾,心脏打击,心脏打击,血液沸腾\n/cast [mod] 黑暗命令\n/use [combat] 13\n/use [combat] 14\n"
                end
            end)(),
            ["血握"] = "#showtooltip\n/cast [@player] 血魔之握\n",
            ["凋零"] = "#showtooltip\n/cast [@player,nochanneling] 枯萎凋零\n",
            -- 符文打击是未选择专精的基础技能
            ["符打"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/petattack\n/cast 符文打击\n/cast [combat] 亡者复生\n/use [combat] 13\n/use [combat] 14\n/use [combat] 改装的邪能焦镜\n/use [combat] 奥拉留斯的低语水晶\n",
            ["灵打"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/petattack\n/cast 灵界打击\n/use [combat] 改装的邪能焦镜\n/use [combat] 奥拉留斯的低语水晶\n",
            ["死握"] = "#showtooltip\n/cast 死亡之握\n/cast 战争践踏(种族特长)\n",
            ["领域"] = "#showtooltip\n/cast [@player] 反魔法领域\n",
            ["白骨"] = (function()
                if player_level < 34 then
                    return "#showtooltip\n/cast 饮血者\n"
                elseif player_level < 50 then
                    return "#showtooltip\n/cast 符文刃舞\n"
                elseif player_level < 54 then
                    return "#showtooltip\n/castsequence reset=90 白骨风暴,符文刃舞,白骨风暴\n"
                else
                    return "#showtooltip\n/castsequence reset=90 白骨风暴,符文刃舞,白骨风暴,亡者复生,牺牲契约\n"
                end
            end)(),
            ["邪"] = (function()
                if player_level < 29 then
                    return "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/petattack\n/castsequence [nomod] reset=combat,6 爆发,暗影之爪\n/cast [mod] 传染\n/cast [combat] 亡者复生\n/use [combat] 13\n/use [combat] 14\n"
                else
                    return "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/petattack\n/castsequence [nomod] reset=combat,6 爆发,暗影之爪,暗影之爪\n/cast [mod] 传染\n/use [combat] 13\n/use [combat] 14\n/use [combat] 改装的邪能焦镜\n/use [combat] 奥拉留斯的低语水晶\n"
                end
            end)(),
            ["传染"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/petattack\n/cast 传染\n",
            ["大便"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/petattack\n/cast 凋零缠绕\n",
            ["邪爆"] = (function()
                if player_level < 29 then
                    return "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/petattack\n/castsequence reset=3 脓疮打击,天启\n"
                else
                    return "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/petattack\n/cast [@pet,noexists] 亡者复生;黑暗突变\n"
                end
            end)(),
            ["冰"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/petattack\n/castsequence reset=combat,6 湮灭,凛风冲击\n/cast [combat] 冰霜之柱\n/cast [combat] 符文武器增效\n/cast [combat] 亡者复生\n/use [combat] 13\n/use [combat] 14\n/use [combat] 改装的邪能焦镜\n/use [combat] 奥拉留斯的低语水晶\n"
        },
        DEMONHUNTER = {
            -- 邪能冲撞=地狱火撞击
            ["跑"] = "#showtooltip\n/cast [nocombat,outdoors] !铁箍鬼灵战马;邪能冲撞\n",
            ["滑翔"] = "/dismount\n/cast !滑翔\n",
            ["变形"] = "#showtooltip\n/cast [@player] 恶魔变形\n",
            ["浩劫"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/castsequence [nochanneling] reset=6,combat 投掷利刃,刃舞\n",
            ["刃舞"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/cast [nochanneling] 刃舞\n/use [combat,nochanneling] 13\n/use [combat,nochanneling] 14\n/use [combat,nochanneling] 审判官的邪恶之眼\n",
            ["混打"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/cast [nochanneling] 混乱打击\n",
            ["眼棱"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/cast [nochanneling] 眼棱\n",
            ["利刃"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/cast [nochanneling] 投掷利刃\n/cast [mod] 折磨\n",
            -- 恶魔之咬=裂魂=破裂
            ["咬"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/cast [nochanneling] 恶魔之咬\n/cast [mod] 折磨\n/cast [combat] 恶魔尖刺\n/cast [@player,combat] 地狱火撞击\n/use [combat] 13\n/use [combat] 14\n/use [combat] 审判官的邪恶之眼\n/use [combat] 庆典烟火\n",
            ["复仇"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/castsequence [talent:4/3] reset=12 破裂,献祭光环,破裂,破裂;reset=6 裂魂,裂魂,裂魂,献祭光环,裂魂,裂魂,裂魂\n/cast [@player,combat] 地狱火撞击\n/cast [combat] 恶魔尖刺\n/cast [mod] 折磨\n",
            ["复防"] = "#showtooltip\n/castsequence [talent:6/3,talent:7/3] reset=30 灵魂壁障,邪能毁灭,灵魂壁障;幽魂炸弹\n",
            ["烈焰"] = "#showtooltip\n/cast [@player,nochanneling] 烈焰咒符\n"
        },
        WARRIOR = {
            ["跑"] = "#showtooltip\n/cast [nocombat,outdoors] 战斗怒吼\n/use [nocombat,outdoors] !铁箍鬼灵战马;英勇飞跃\n",
            ["乘胜"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/cast 乘胜追击\n/cast 冲锋\n/cast 盾牌格挡\n/cast 无视苦痛\n",
            ["冲锋"] = "#showtooltip\n/cast [help] 援护;冲锋\n/cast 断筋\n",
            ["盾猛"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/cast 盾牌猛击\n/cast [mod] 嘲讽\n/cast [combat,group] 盾牌格挡\n/cast [combat,group] 无视苦痛\n/cast [combat] 天神下凡\n/cast [combat] 法术反射\n/use [combat] 13\n/use [combat] 14\n",
            ["雷霆"] = "#showtooltip\n/cast 雷霆一击\n/cast [combat,group] 盾牌格挡\n/cast [combat,group] 无视苦痛\n/use [combat] 改装的邪能焦镜\n/use [combat] 奥拉留斯的低语水晶\n",
            ["复仇"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/cast 复仇\n",
            ["拳击"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/cast 拳击\n/cast 英勇投掷\n",
            ["挫志"] = "#showtooltip\n/castsequence [@player] reset=45 挫志怒吼,巨龙怒吼,破坏者,巨龙怒吼,挫志怒吼,巨龙怒吼,破坏者\n",
            ["斩杀"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/cast 斩杀\n/cast 冲锋\n",
            ["狂怒"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/castsequence reset=3 嗜血,旋风斩,盾牌猛击,嗜血,旋风斩,旋风斩\n/cast [combat] 无视苦痛\n/cast [combat] 盾牌格挡\n/cast [combat] 鲁莽\n",
            ["巨人"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/castsequence [@player] reset=45 灭战者,横扫攻击,破坏者,横扫攻击,灭战者,破坏者,横扫攻击\n",
            ["压制"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/castsequence reset=12 压制,致死打击\n",
            ["旋风"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/cast 旋风斩\n/cast [combat] 法术反射\n/use [combat] 13\n/use [combat] 14\n/use [combat] 改装的邪能焦镜\n/use [combat] 奥拉留斯的低语水晶\n"
        },
        PALADIN = {
            ["跑"] = "#showtooltip\n/cast [mounted] !十字军光环\n/use [nocombat,outdoors,spec:1] !大领主的英勇战马\n/use [nocombat,outdoors,spec:2] !大领主的警戒战马\n/use [nocombat,outdoors,spec:3] !大领主的复仇战马\n/cast [combat][indoors] 神圣马驹\n",
            ["防护"] = (function()
                if player_level < 14 then
                    -- return "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/castsequence reset=6 审判,奉献,十字军打击,审判,十字军打击,奉献,审判,十字军打击\n/cast [combat] 正义盾击\n/use [combat] 13\n/use [combat] 14\n/use [combat] 1\n"
                    return "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/castsequence reset=6 审判,奉献,十字军打击,审判,十字军打击,奉献,审判,十字军打击\n/use [combat] 13\n/use [combat] 14\n/use [combat] 1\n"
                elseif player_level < 23 then
                    -- return "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/castsequence reset=6 审判,奉献,!祝福之锤,审判,!祝福之锤,奉献,审判,!祝福之锤\n/cast [combat] 复仇之怒\n/use [combat] 13\n/use [combat] 14\n/use [combat] 1\n/use [combat] 庆典烟火\n"
                    return "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/castsequence reset=6 审判,奉献,!祝福之锤,审判,!祝福之锤,奉献,审判,!祝福之锤\n/cast [mod] 清算之手\n/cast [combat] 正义盾击\n/cast [combat] 复仇之怒\n/use [combat] 13\n/use [combat] 14\n/use [combat] 1\n/use [combat] 庆典烟火\n"
                else
                    return "#showtooltip\n/cast [noform:2] 虔诚光环\n/targetenemy [noharm][dead]\n/startattack\n/castsequence reset=6 审判,奉献,!祝福之锤,审判,奉献,!祝福之锤,奉献,审判,!祝福之锤,奉献\n/cast [mod] 清算之手\n/cast [combat] 正义盾击\n/cast [combat] 复仇之怒\n/use [combat] 13\n/use [combat] 14\n"
                end
            end)(),
            ["飞盾"] = player_level < 28 and "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/cast 复仇者之盾\n" or
                "#showtooltip\n/cast [noform:2] 虔诚光环\n/targetenemy [noharm][dead]\n/startattack\n/cast 复仇者之盾\n",
            ["光"] = "#showtooltip\n/cast [@player]荣耀圣令 \n",
            ["斩杀"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/cast 愤怒之锤\n",
            ["惩戒"] = "#showtooltip\n/cast [noform:2] 虔诚光环\n/targetenemy [noharm][dead]\n/startattack\n/castsequence reset=9 审判,十字军打击,奉献,公正之剑,十字军打击\n/use [combat] 13\n/use [combat] 14\n/use [combat] 改装的邪能焦镜\n/use [combat] 奥拉留斯的低语水晶\n"
        },
        SHAMAN = {
            ["跑"] = "#showtooltip\n/cast [nocombat,outdoors,@player] 水上行走\n/use [nocombat,outdoors] !铁箍鬼灵战马;!幽魂之狼\n",
            ["狼"] = "#showtooltip\n/cast !幽魂之狼\n",
            ["净化"] = "#showtooltip\n/cast [harm] 净化术\n/cast 净化灵魂\n",
            ["恢复"] = (function()
                -- 27级治疗波
                if player_level < 27 then
                    return "#showtooltip\n/castsequence reset=6 !激流,治疗之涌,治疗链,治疗之涌\n"
                else
                    return "#showtooltip\n/castsequence [talent:6/1] reset=6 !激流,治疗波,治疗链,治疗波,治疗波\n/castsequence [notalent:6/1] reset=6 !激流,治疗波,治疗链,治疗波\n"
                end
            end)(),
            ["灵魂"] = "#showtooltip\n/cast [@player] 灵魂链接图腾\n",
            ["火震"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/cast 烈焰震击\n",
            ["闪电"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/petattack\n/cast [nomod] 闪电箭\n/cast [mod] 闪电链\n/cast [combat] 流星\n/cast [combat] 风暴之眼\n/use [combat] 13\n/use [combat] 14\n/use [combat] 奥拉留斯的低语水晶\n",
            ["电链"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/petattack\n/cast 闪电链\n/cast [combat] 流星\n/cast [combat] 风暴之眼\n/use [combat] 13\n/use [combat] 14\n/use [combat] 奥拉留斯的低语水晶\n",
            ["熔岩"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/petattack\n/cast 熔岩爆裂\n",
            ["冰震"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/cast [nomod] 冰霜震击\n/cast [mod] 闪电链\n/cast [combat] 流星\n/cast [combat] 风暴之眼\n/use [combat] 13\n/use [combat] 14\n/use [combat] 奥拉留斯的低语水晶\n",
            ["地震"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/cast [@cursor] 地震术\n",
            ["雷霆"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/cast [@player] 雷霆风暴\n",
            ["电能"] = "#showtooltip\n/cast [@player] 电能图腾\n"
        },
        PRIEST = {
            ["跑"] = "#showtooltip\n/cast [spec:3,noform] !暗影形态\n/cast [nocombat,outdoors,@player] 真言术：韧\n/use [nocombat,outdoors] !大祭司的光誓寻觅者\n/cast [combat,spec:2,talent:2/3,@player][indoors,spec:2,talent:2/3,@player] 天堂之羽\n",
            ["羽"] = "#showtooltip\n/cast [@player] 天堂之羽\n",
            ["漂浮"] = "#showtooltip\n/cast [@player] 漂浮术\n",
            ["韧"] = "#showtooltip\n/cast [@player] 真言术：韧\n",
            ["净化"] = "#showtooltip\n/cast [harm] 驱散魔法\n/cast [spec:1/2] 纯净术\n/cast [spec:3] 净化疾病\n",
            ["群驱"] = "#showtooltip\n/cast [@player] 群体驱散\n",
            ["震爆"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/cast 心灵震爆\n",
            ["惩击"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/cast [nomod,nochanneling] 惩击\n/cast [mod,nochanneling] 精神灼烧\n", -- 也是心灵鞭笞
            ["罚"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/cast 圣言术：罚\n",
            ["神圣"] = player_level > 20 and
                "#showtooltip\n/castsequence [group] reset=combat,6 快速治疗,治疗术\n/castsequence [nogroup,@player] reset=combat,9 真言术：盾,恢复,愈合祷言,真言术：盾,快速治疗,快速治疗,快速治疗\n" or
                "#showtooltip\n/castsequence reset=target,6 真言术：盾,恢复,快速治疗,治疗术\n",
            ["灵"] = "#showtooltip\n/cast [@player] 圣言术：灵\n",
            ["痛"] = "#showtooltip\n/targetenemy [nomod,noharm][nomod,dead]\n/startattack [nomod]\n/cast [nomod] 暗言术：痛;神圣新星\n/use [combat] 13\n/use [combat] 14\n/use [combat] 改装的邪能焦镜\n/use [combat] 奥拉留斯的低语水晶\n/use [combat] 庆典烟火\n",
            ["新星"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/cast 神圣新星\n",
            ["苦修"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/cast 苦修\n",
            ["戒律"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/castsequence [nochanneling] reset=6 真言术：盾,净化邪恶,苦修,精神灼烧\n"
        },
        WARLOCK = {
            ["跑"] = "#showtooltip\n/use [nocombat,outdoors] !铁箍鬼灵战马;爆燃冲刺\n",
            ["吸血"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/petattack\n/cast [nochanneling:吸取生命] 吸取生命\n",
            ["暗箭"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/petattack\n/cast [nochanneling:吸取灵魂] 暗影箭\n",
            ["痛苦"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/petattack\n/castsequence [talent:2/3] reset=target,combat,6 痛楚,生命虹吸,腐蚀术\n/castsequence reset=target,combat,12 痛楚,痛苦无常\n/use [combat] 13\n/use [combat] 14\n/use [combat] 改装的邪能焦镜\n/use [combat] 奥拉留斯的低语水晶\n",
            ["腐蚀"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/petattack\n/cast 腐蚀术\n",
            ["腐种"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/petattack\n/cast [talent:4/2] 诡异魅影\n/cast [talent:4/3] 邪恶污染\n/cast [notalent:4/2,notalent:4/3] 腐蚀之种\n"
        },
        MONK = {
            ["跑"] = "#showtooltip\n/use [nocombat,outdoors] !班禄，大宗师的伙伴;滚地翻\n",
            ["火焰"] = "#showtooltip\n/cast 火焰之息\n/cast [mod] 嚎镇八方\n",
            ["酒仙"] = (function()
                if player_level < 21 then
                    return "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/castsequence [nochanneling] reset=4 幻灭踢,神鹤引项踢,神鹤引项踢\n/cast 碧玉疾风\n/cast [mod] 嚎镇八方\n/cast [combat] 活血酒\n/use [combat] 13\n/use [combat] 14\n/use [combat] 改装的邪能焦镜\n/use [combat] 奥拉留斯的低语水晶\n"
                else
                    return "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/castsequence [nochanneling] reset=4 幻灭踢,醉酿投,神鹤引项踢,幻灭踢,神鹤引项踢,醉酿投,幻灭踢,神鹤引项踢\n/cast [mod] 嚎镇八方\n/cast [combat] 活血酒\n/use [combat] 13\n/use [combat] 14\n/use [combat] 改装的邪能焦镜\n/use [combat] 奥拉留斯的低语水晶\n"
                end
            end)(),
            -- ["酒仙"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/castsequence [nochanneling] reset=4 神鹤引项踢,醉酿投,神鹤引项踢,幻灭踢\n/cast [combat] 碧玉疾风\n/cast [mod] 嚎镇八方\n/cast [combat] 活血酒\n/use [combat] 13\n/use [combat] 14\n/use [combat] 改装的邪能焦镜\n/use [combat] 奥拉留斯的低语水晶\n",
            ["天神"] = "#showtooltip\n/cast 天神酒\n/cast [combat] 金创药\n/use [combat] 2 \n",
            ["切喉"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/cast 切喉手\n",
            ["禅意"] = "#showtooltip\n/dismount\n/cast !禅意飞行\n",
            ["神鹤"] = "#showtooltip\n/cast [nochanneling:神鹤引项踢] 神鹤引项踢\n",
            ["织雾"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/castsequence reset=combat,18 猛虎掌,幻灭踢\n",
            ["旭日"] = "#showtooltip\n/targetenemy [noharm][dead]\n/startattack\n/cast 旭日东升踢\n"
        }
    }

    if InCombatLockdown() then
        return
    end
    -- if UnitLevel("player") > 20 then
    --     return
    -- end

    local gn, pcn = GetNumMacros()
    -- 通用宏
    for i = gn, 1, -1 do
        if not global_macros[({GetMacroInfo(i)})[1]] then
            DeleteMacro(i)
        end
    end
    for n, b in pairs(global_macros) do
        local i = GetMacroIndexByName(n)
        if i == 0 or i > 120 then
            print("CreateMacro", n)
            CreateMacro(n, "INV_Misc_QuestionMark", b, nil, 1)
        elseif GetMacroBody(i) ~= b then
            print("EditMacro", n)
            EditMacro(i, nil, nil, b)
        end
    end
    -- 角色专用宏
    local per_char_macros = class_macros[({UnitClass("player")})[2]]
    if per_char_macros then
        for i = pcn + 120, 121, -1 do
            if not per_char_macros[({GetMacroInfo(i)})[1]] then
                DeleteMacro(i)
            end
        end
        for n, b in pairs(per_char_macros) do
            local i = GetMacroIndexByName(n)
            if i == 0 or i < 121 then
                print("CreateMacro", n)
                CreateMacro(n, "INV_Misc_QuestionMark", b, 1, 1)
            elseif GetMacroBody(i) ~= b then
                print("EditMacro", n)
                EditMacro(i, nil, nil, b)
            end
        end
    end
end
